## t50 5.8.2

=== Makefile ===
# vim: set noet :
#
#     __________ ________  _____
#    |__    ___/|   ____/ /  _  \ the fastest packet injector.
#      |    |   |____  \ /  /_\  \
#      |    |   /       \\  \_/   \
#      |____|  /________/\\_______/
#
# NOTE: I've got rid of autoconf 'cause there is a dependency there.
#       This way you don't need anything other than this makefile to
#       compile the project.

VERSION=5.8.2

# Change it to clang if you feel lucky!
CC=gcc
LD=$(CC)

INCLUDEDIR=src/include
CFLAGS=-std=gnu11
LDFLAGS=
LDLIBS=

# Just define DEBUG environment var to compile for debugging:
#
# $ DEBUG=1 make
#
ifdef DEBUG
	CFLAGS += -O0 -g
else
  # Optimization level 2 (better results) and no canaries.
  CFLAGS += -O2 -DNDEBUG

  ARCHITECTURE = $(shell arch)

  # Options for x86-64
  ifeq ($(ARCHITECTURE),x86_64)
    CFLAGS += -march=native -ftree-vectorize -flto -fno-stack-protector
    LDFLAGS += -flto
  endif
  # Options for i386
  ifeq ($(ARCHITECTURE),i686)
    CFLAGS += -march=native -flto -fno-stack-protector
    LDFLAGS += -flto
  endif

	# TODO: tunning for cortex-a#?
  # Options for ARMv7-a
  ifneq ($(findstr armv7,$(ARCHITECTURE)),)
    CFLAGS += -march=armv7-a -fno-stack-protector -flto
    LDFLAGS += -flto
  endif
  # Options for ARMv8-a
  ifneq ($(findstr armv8,$(ARCHITECTURE)),)
    CFLAGS += -march=armv8-a -fno-stack-protector -flto
    LDFLAGS += -flto
  endif

  # strip symbols and turn more linker optimizations on (if available).
  LDFLAGS += -s -O2
endif

CFLAGS += -I $(INCLUDEDIR) -std=gnu11

# Added to use ANSI CSI codes (beautifier).
ifdef USE_ANSI
	CFLAGS += -DUSE_ANSI
endif

EXECUTABLE=bin/t50

OBJECTS=\
src/cidr.o \
src/cksum.o \
src/config.o \
src/errors.o \
src/main.o \
src/memalloc.o \
src/modules.o \
src/netio.o \
src/randomizer.o \
src/shuffle.o \
src/usage.o \
src/help/egp_help.o \
src/help/eigrp_help.o \
src/help/general_help.o \
src/help/gre_help.o \
src/help/icmp_help.o \
src/help/igmp_help.o \
src/help/ip_help.o \
src/help/ipsec_help.o \
src/help/ospf_help.o \
src/help/rip_help.o \
src/help/rsvp_help.o \
src/help/tcp_udp_dccp_help.o \
src/modules/dccp.o \
src/modules/egp.o \
src/modules/eigrp.o \
src/modules/gre.o \
src/modules/icmp.o \
src/modules/igmpv1.o \
src/modules/igmpv3.o \
src/modules/ip.o \
src/modules/ipsec.o \
src/modules/ospf.o \
src/modules/ripv1.o \
src/modules/ripv2.o \
src/modules/rsvp.o \
src/modules/tcp.o \
src/modules/udp.o

.PHONY: all clean distclean dist install uninstall

all: $(EXECUTABLE)

# Now we'll compile to ./bin/ directory!
# Explicit rule needed 'cause we have multiple objects.
$(EXECUTABLE): $(OBJECTS)
	$(LD) $(LDFLAGS) -o $@ $^ $(LDLIBS)

# Implicit rules (all .c files will be compiled!)
src/%.o: src/%.c
src/help/%.o: src/help/%.c
src/modules/%.o: src/modules/%.c

# 'clean' only deletes the object files.
clean:
	@echo 'Deleting .o files...'
	-find src/ -type f -name '*.o' -delete

# distclean delete the object files AND the executable.
distclean: clean
	-rm $(EXECUTABLE) dist/*.gz dist/*.asc

# Shortcut to check if user has root privileges.
define checkifroot
	if [ `id -u` -ne 0 ]; then \
		echo 'Need root privileges!'; \
		exit 1; \
	fi
endef

# install and uninstall rules are very simple!
install:
	@$(call checkifroot)
	@if [ ! -e "$(EXECUTABLE)" ]; then \
		echo "Try 'make' first."; \
		exit 1; \
	fi;
	cp bin/t50 /sbin/; cp doc/t50.8 /usr/share/man/man8/; \
	chown root: /sbin/t50 /usr/share/man/man8; \
	chmod 0750 /sbin/t50; \
	gzip -9 /usr/share/man/man8/t50.8; \
	chmod 0664 /usr/share/man/man8/t50.8.gz

uninstall:
	@$(call checkifroot)
	rm /sbin/t50 /usr/share/man/man8/t50.8.gz

# Needed to build the project source tarball (no signature generation here).
dist: distclean
	tar -czvf dist/t50-$(VERSION).tar.gz --exclude=*.tar.gz --exclude=*.asc *

## t50 5.6.4

=== debian/changelog ===
t50 (5.6.4-1) unstable; urgency=low

  * Initial release to Debian.
  * Fix watch file
  * Imported Upstream version 5.6.4
  * Delete rules file overrides
  * Delete dirs file. No need for it
  * Set proper values to control file fields
  * Build with autoreconf
  * Set hardening options
  * Fix description field in control file
  * Fix minor spelling errors. Lintian is happier now
  * Fix copyright file
  * Bump standards-version to 3.9.8
  * Include README.modules in docs.

 -- Marcos Fouces <mfouces@yahoo.es>  Thu, 28 Jul 2016 11:47:05 +0200

t50 (5.4.1-rc1-1kali1) kali; urgency=low

  * Fixed build for 32 bit

 -- Devon Kearns <dookie@kali.org>  Thu, 27 Dec 2012 05:46:12 -0700

t50 (5.4.1-rc1-1kali0) kali; urgency=low

  * Initial release 

 -- Devon Kearns <dookie@kali.org>  Wed, 26 Dec 2012 11:18:29 -0700

=== debian/control ===
Source: t50
Section: utils
Priority: optional
Maintainer: Debian Security Tools Packaging Team <pkg-security-team@lists.alioth.debian.org>
Uploaders: Marcos Fouces <mfouces@yahoo.es>
Build-Depends: debhelper (>= 9.0.0), dh-autoreconf
Standards-Version: 3.9.8
Homepage: https://github.com/fredericopissarra/t50
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-security/t50.git
Vcs-Git: https://anonscm.debian.org/git/pkg-security/t50.git


Package: t50
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Multi-protocol packet injector tool
 Multi-protocol packet injector tool for *nix systems, 
 actually supporting 15 protocols.
 .
 Features:
 .
  - Flooding
  - CIDR support
  - TCP, UDP, ICMP, IGMPv2, IGMPv3, EGP, DCCP, RSVP, RIPv1, 
 RIPv2, GRE, ESP, AH, EIGRP and OSPF support.
  - TCP Options.
  - High performance.
  - Can hit about 1.000.000 packets per second.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

%:
	dh $@ --with autoreconf

=== debian/watch ===
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/t50-$1\.tar\.gz/ \
  https://github.com/fredericopissarra/t50/tags .*/v?(\d\S*)\.tar\.gz

## t50 5.6.7

=== debian/changelog ===
t50 (5.6.7-1) unstable; urgency=medium

  * New upstream version 5.6.7
  * Fix set-proper-compiler-flags.patch to reflect upstream changes.

 -- Marcos Fouces <mfouces@yahoo.es>  Thu, 01 Sep 2016 22:59:52 +0200

t50 (5.6.6-1) unstable; urgency=high

  * New upstream release.
  * debian/patches:
    - series: Remove fix-spelling-errors.patch, applied upstream.
    - autoreconf-version-number.patch: Add patch, upstream forgot to change
      version number.
    - set-proper-compiler-flags.patch: Update to reflect upstream changes.

 -- Samuel Henrique <samueloph@gmail.com>  Mon, 29 Aug 2016 10:19:21 -0300

t50 (5.6.4-2) unstable; urgency=medium

  [ Samuel Henrique ]
  * Change debian/patches/set-proper-compiler-flags.patch to empty CFLAGS.
    The build system will inject sane default flags for us. We thus get
    rid of the problematic -march=native.
  * Enable pie hardening, it seems to work.
  * Bump watch to v4.
  * Add myself as an uploader.
  * Add myself as copyright holder.

  [ Marcos ]
  * Fix changelog and control file

  [ Raphaël Hertzog ]
  * Set architecture to linux-any.

 -- Samuel Henrique <samueloph@gmail.com>  Fri, 26 Aug 2016 10:21:16 +0200

=== debian/control ===
Source: t50
Section: utils
Priority: optional
Maintainer: Debian Security Tools Packaging Team <pkg-security-team@lists.alioth.debian.org>
Uploaders: Marcos Fouces <mfouces@yahoo.es>,
           Samuel Henrique <samueloph@gmail.com>
Build-Depends: debhelper (>=9), dh-autoreconf
Standards-Version: 3.9.8
Homepage: https://github.com/fredericopissarra/t50
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-security/t50.git
Vcs-Git: https://anonscm.debian.org/git/pkg-security/t50.git

Package: t50
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Multi-protocol packet injector tool
 Multi-protocol packet injector tool for *nix systems,
 actually supporting 15 protocols.
 .
 Features:
 .
  - Flooding
  - CIDR support
  - TCP, UDP, ICMP, IGMPv2, IGMPv3, EGP, DCCP, RSVP, RIPv1,
 RIPv2, GRE, ESP, AH, EIGRP and OSPF support.
  - TCP Options.
  - High performance.
  - Can hit about 1.000.000 packets per second.

## t50 5.6.8

=== debian/changelog ===
t50 (5.6.8-1) unstable; urgency=medium

  * New upstream version 5.6.8
  * Delete disable-linux-test.patch. It is already applied upstream.
  * Update to debhelper 10.

 -- Marcos Fouces <mfouces@yahoo.es>  Wed, 12 Oct 2016 21:18:13 +0200

t50 (5.6.7-2) unstable; urgency=high

  * debian/patches/disable-linux-test.patch: Create patch to avoid FTBFS on
    systems where host_os != linux-gnu. Thanks to Gianfranco Costamagna.

 -- Marcos Fouces <mfouces@yahoo.es>  Mon, 05 Sep 2016 18:30:46 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Security Tools Packaging Team <pkg-security-team@lists.alioth.debian.org>
 Uploaders: Marcos Fouces <mfouces@yahoo.es>,
            Samuel Henrique <samueloph@gmail.com>
-Build-Depends: debhelper (>=9), dh-autoreconf
+Build-Depends: debhelper (>=10), dh-autoreconf
 Standards-Version: 3.9.8
 Homepage: https://github.com/fredericopissarra/t50
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-security/t50.git

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/t50-$1\.tar\.gz/ \
  https://github.com/fredericopissarra/t50/tags .*/v?(\d\S*)\.tar\.gz

## t50 5.6.13

=== debian/changelog ===
t50 (5.6.13-2) unstable; urgency=medium

  * d/p/ftbfs_i386: new patch to remove extra comma. Thanks to
    "Fernando Debian" for the help confirming and testing the fix
    (closes: #865785).

 -- Samuel Henrique <samueloph@gmail.com>  Sun, 25 Jun 2017 13:12:09 -0300

t50 (5.6.13-1) unstable; urgency=medium

  * New upstream version 5.6.13
  * Remove unneeded patch. Upstream doesn't use CPU
    specific flags anymore.
  * Remove unneeded dh-autoreconf build dependency. dh 10
    use it by default.

  [ Samuel Henrique ]
  * Bump Standards-Version to 4.0.0.
  * debian/patch/gcc_flags: New patch to address CFLAGS, needed for new release.

 -- Marcos Fouces <marcos.fouces@gmail.com>  Sun, 18 Jun 2017 22:33:38 +0200

## t50 5.6.15

=== debian/changelog ===
t50 (5.6.15-1) unstable; urgency=medium

  * New upstream version 5.6.15
  * d/patches: remove all patches, applied upstream, thanks to Lukas
    Schwaighofer <lukas@schwaighofer.name> for helping with makefile flags.

 -- Samuel Henrique <samueloph@gmail.com>  Mon, 03 Jul 2017 21:55:12 -0300

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: utils
 Priority: optional
 Maintainer: Debian Security Tools Packaging Team <pkg-security-team@lists.alioth.debian.org>
-Uploaders: Marcos Fouces <mfouces@yahoo.es>,
+Uploaders: Marcos Fouces <marcos.fouces@gmail.com>,
            Samuel Henrique <samueloph@gmail.com>
-Build-Depends: debhelper (>=10), dh-autoreconf
-Standards-Version: 3.9.8
+Build-Depends: debhelper (>=10)
+Standards-Version: 4.0.0
 Homepage: https://github.com/fredericopissarra/t50
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-security/t50.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-security/t50.git

## t50 5.7.0

=== debian/changelog ===
t50 (5.7.0-2) unstable; urgency=medium

  * Do not use "native" flags (Closes: #870087)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 29 Jul 2017 19:51:17 +0200

t50 (5.7.0-1) unstable; urgency=medium

  * New upstream version 5.7.0
  * d/p/manpage_typos: new patch to fix typos
  * d/watch: mangle beta/alpha releases

 -- Samuel Henrique <samueloph@gmail.com>  Sat, 29 Jul 2017 10:31:14 -0300

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/t50-$1\.tar\.gz/i,\
  uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/ \
  https://github.com/fredericopissarra/t50/tags .*/v?(\d\S*)\.tar\.gz

## t50 5.7.1

=== debian/changelog ===
t50 (5.7.1-1) unstable; urgency=medium

  [ Samuel Henrique ]
  * d/control: fix Description indentation

  [ Raphaël Hertzog ]
  * Update team maintainer address to
    Debian Security Tools <team+pkg-security@tracker.debian.org>
  * Update Vcs-Git and Vcs-Browser for the move to salsa.debian.org

  [ Marcos Fouces ]
  * Use secure url format in copyright file
  * Update copyright year
  * Bump to dh compat level 11
  * New upstream version 5.7.1
  * Rework patches for new upstream release
    ~ Remove manpage_typos.patch (applied upstream)
    ~ Refresh disable-native.patch
    ~ Add fix-flags.patch
  * Add cryptographic signature verification
  * Add some upstream metadata
  * Bump to Standards-version 4.1.3

 -- Marcos Fouces <marcos.fouces@gmail.com>  Sun, 11 Mar 2018 16:21:53 +0100

=== debian/control ===
Source: t50
Section: utils
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Marcos Fouces <marcos.fouces@gmail.com>,
           Samuel Henrique <samueloph@gmail.com>
Build-Depends: debhelper (>=11)
Standards-Version: 4.1.3
Homepage: https://github.com/fredericopissarra/t50
Vcs-Browser: https://salsa.debian.org/pkg-security-team/t50
Vcs-Git: https://salsa.debian.org/pkg-security-team/t50.git

Package: t50
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Multi-protocol packet injector tool
 Multi-protocol packet injector tool for *nix systems,
 actually supporting 15 protocols.
 .
 Features:
 .
  - Flooding
  - CIDR support
  - TCP, UDP, ICMP, IGMPv2, IGMPv3, EGP, DCCP, RSVP, RIPv1,
    RIPv2, GRE, ESP, AH, EIGRP and OSPF support.
  - TCP Options.
  - High performance.
  - Can hit about 1.000.000 packets per second.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ https://github.com/fredericopissarra/t50/releases .*/v?(\d\S*)\.tar\.gz

## t50 5.8.2

=== debian/changelog ===
t50 (5.8.2-3) unstable; urgency=high

  * d/p/01_Fix-Makefile.patch: Update to remove march-native flag,
    there was still flag missed by the last change for i686.

 -- Samuel Henrique <samueloph@debian.org>  Mon, 12 Nov 2018 12:39:00 -0200

t50 (5.8.2-2) unstable; urgency=high

  * d/u/metadata: update urls to gitlab
  * d/p/01_Fix-Makefile.patch: Update to remove march-native flag
    (closes: #911971)

 -- Samuel Henrique <samueloph@debian.org>  Fri, 26 Oct 2018 16:38:49 -0300

t50 (5.8.2-1) unstable; urgency=medium

  [ Marcos Fouces ]
  * New upstream version 5.8.2
  * Bump to Standards-Version: 4.2.1 (no changes required)
  * Delete all previous patches as patched files no longer exists.
  * Create 01_Fix-Makefile.patch
  * Update control, copyright and watch file to reflect new homepage at Gitlab.
  * Update pgpsigurlmangle option in watch file

  [ Samuel Henrique ]
  * Update my email to @debian.org

  [ Raphaël Hertzog ]
  * Update watch file to track sf.net with GPG signature.

 -- Marcos Fouces <marcos.fouces@gmail.com>  Tue, 25 Sep 2018 23:36:39 +0200

## t50 5.8.3

=== Makefile ===
--- 
+++ 
@@ -10,9 +10,8 @@
 #       This way you don't need anything other than this makefile to
 #       compile the project.
 
-VERSION=5.8.2
+VERSION=5.8.3
 
-# Change it to clang if you feel lucky!
 CC=gcc
 LD=$(CC)
 
@@ -20,6 +19,14 @@
 CFLAGS=-std=gnu11
 LDFLAGS=
 LDLIBS=
+
+# Check GCC version (must be 5 or greater)
+# OBS: This makes compilation GCC dependent (cannot use clang).
+#      If you are feeling lucky, comment these lines and change CC to 'clang'.
+GCCVERSION=$(shell expr "`gcc -dumpversion | sed -n 's/^\([0-9]\+\)\.*.*$$/\1/p'`" \>= 5)
+ifeq "$(GCCVERSION)" "0"
+  $(error "T50 will compile only with GCC 5 or greater")
+endif
 
 # Just define DEBUG environment var to compile for debugging:
 #

=== debian/changelog ===
t50 (5.8.3-2) unstable; urgency=medium

  * d/p/01_Fix-Makefile.patch: Remove buggy Arch detection and specific flags.

 -- Samuel Henrique <samueloph@debian.org>  Mon, 13 May 2019 23:44:32 +0100

t50 (5.8.3-1) unstable; urgency=medium

  * New upstream version 5.8.3
  * Rework patches for new upstream version.

 -- Marcos Fouces <marcos.fouces@gmail.com>  Fri, 30 Nov 2018 00:10:19 +0100

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Marcos Fouces <marcos.fouces@gmail.com>,
-           Samuel Henrique <samueloph@gmail.com>
+           Samuel Henrique <samueloph@debian.org>
 Build-Depends: debhelper (>=11)
-Standards-Version: 4.1.3
-Homepage: https://github.com/fredericopissarra/t50
+Standards-Version: 4.2.1
+Homepage: https://gitlab.com/fredericopissarra/t50
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/t50
 Vcs-Git: https://salsa.debian.org/pkg-security-team/t50.git

## t50 5.8.5

=== debian/changelog ===
t50 (5.8.5-2) unstable; urgency=medium

  * Switch to debhelper-compat from DH 12.

 -- Marcos Fouces <marcos.fouces@gmail.com>  Mon, 16 Sep 2019 23:09:38 +0200

t50 (5.8.5-1) unstable; urgency=medium

  [ Marcos Fouces ]
  * New upstream version 5.8.5
  * Refresh patches.
  * Fix FTCBFS: Use the makefile buildsystem for dh_auto_build.
    Thanks to Helmut Grohne (Closes: #930208).

  [ Samuel Henrique ]
  * Bump DH level to 12
  * Bump Standards-Version to 4.4.0

 -- Marcos Fouces <marcos.fouces@gmail.com>  Sun, 15 Sep 2019 19:50:18 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Marcos Fouces <marcos.fouces@gmail.com>,
            Samuel Henrique <samueloph@debian.org>
-Build-Depends: debhelper (>=11)
-Standards-Version: 4.2.1
+Build-Depends: debhelper-compat (=12)
+Standards-Version: 4.4.0
 Homepage: https://gitlab.com/fredericopissarra/t50
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/t50
 Vcs-Git: https://salsa.debian.org/pkg-security-team/t50.git

## t50 5.8.7

=== Makefile ===
--- 
+++ 
@@ -10,23 +10,20 @@
 #       This way you don't need anything other than this makefile to
 #       compile the project.
 
-VERSION=5.8.3
+VERSION=5.8.7
 
-CC=gcc
+#CC=gcc
+#
+# OBS: T50 will compile only on GCC 5 or above. If you are feeling lucky,
+#      try GCC 4.9 or CLANG... But I don't recomended.
+#
+
 LD=$(CC)
 
 INCLUDEDIR=src/include
-CFLAGS=-std=gnu11
+CFLAGS=-std=gnu11 -I $(INCLUDEDIR)
 LDFLAGS=
 LDLIBS=
-
-# Check GCC version (must be 5 or greater)
-# OBS: This makes compilation GCC dependent (cannot use clang).
-#      If you are feeling lucky, comment these lines and change CC to 'clang'.
-GCCVERSION=$(shell expr "`gcc -dumpversion | sed -n 's/^\([0-9]\+\)\.*.*$$/\1/p'`" \>= 5)
-ifeq "$(GCCVERSION)" "0"
-  $(error "T50 will compile only with GCC 5 or greater")
-endif
 
 # Just define DEBUG environment var to compile for debugging:
 #
@@ -36,7 +33,10 @@
 	CFLAGS += -O0 -g
 else
   # Optimization level 2 (better results) and no canaries.
-  CFLAGS += -O2 -DNDEBUG
+  CFLAGS += -O2 -DNDEBUG -ffast-math
+
+  # strip symbols and turn more linker optimizations on (if available).
+  LDFLAGS += -s -O2
 
   ARCHITECTURE = $(shell arch)
 
@@ -51,27 +51,24 @@
     LDFLAGS += -flto
   endif
 
-	# TODO: tunning for cortex-a#?
+  # TODO: tunning for arm-cortex-a7? (Raspberry PI?)
+  # TODO: aarch64?!
   # Options for ARMv7-a
-  ifneq ($(findstr armv7,$(ARCHITECTURE)),)
+  ifneq ($(findstring armv7,$(ARCHITECTURE)),)
     CFLAGS += -march=armv7-a -fno-stack-protector -flto
     LDFLAGS += -flto
   endif
+
   # Options for ARMv8-a
-  ifneq ($(findstr armv8,$(ARCHITECTURE)),)
+  ifneq ($(findstring armv8,$(ARCHITECTURE)),)
     CFLAGS += -march=armv8-a -fno-stack-protector -flto
     LDFLAGS += -flto
   endif
-
-  # strip symbols and turn more linker optimizations on (if available).
-  LDFLAGS += -s -O2
 endif
-
-CFLAGS += -I $(INCLUDEDIR) -std=gnu11
 
 # Added to use ANSI CSI codes (beautifier).
 ifdef USE_ANSI
-	CFLAGS += -DUSE_ANSI
+  CFLAGS += -DUSE_ANSI
 endif
 
 EXECUTABLE=bin/t50
@@ -156,9 +153,9 @@
 	fi;
 	cp bin/t50 /sbin/; cp doc/t50.8 /usr/share/man/man8/; \
 	chown root: /sbin/t50 /usr/share/man/man8; \
-	chmod 0750 /sbin/t50; \
+	chmod 4750 /sbin/t50; \
 	gzip -9 /usr/share/man/man8/t50.8; \
-	chmod 0664 /usr/share/man/man8/t50.8.gz
+	chmod 0644 /usr/share/man/man8/t50.8.gz
 
 uninstall:
 	@$(call checkifroot)

=== debian/changelog ===
t50 (5.8.7-1) unstable; urgency=medium

  * New upstream version 5.8.7
  * Bump Standards-Version to 4.4.1
  * d/control: Add Rules-Requires-Root: no
  * d/patches:
    - 01_Fix-Makefile.patch: Update patch
    - build_without_root_perms.patch: Remove unneeded makefile step to allow
      non-root build
  * Add salsa-ci.yml

 -- Samuel Henrique <samueloph@debian.org>  Sat, 04 Jan 2020 18:31:32 +0000

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,9 @@
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Marcos Fouces <marcos.fouces@gmail.com>,
            Samuel Henrique <samueloph@debian.org>
-Build-Depends: debhelper-compat (=12)
-Standards-Version: 4.4.0
+Build-Depends: debhelper-compat (= 12)
+Standards-Version: 4.4.1
+Rules-Requires-Root: no
 Homepage: https://gitlab.com/fredericopissarra/t50
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/t50
 Vcs-Git: https://salsa.debian.org/pkg-security-team/t50.git

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/" \
https://sf.net/t50/t50-@ANY_VERSION@@ARCHIVE_EXT@

# To match tags on the git repository:
#https://gitlab.com/fredericopissarra/t50/tags (?:.*/)@PACKAGE@-v@ANY_VERSION@@ARCHIVE_EXT@

## t50 5.8.7b

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,3 @@
-# vim: set noet :
 #
 #     __________ ________  _____
 #    |__    ___/|   ____/ /  _  \ the fastest packet injector.
@@ -10,7 +9,7 @@
 #       This way you don't need anything other than this makefile to
 #       compile the project.
 
-VERSION=5.8.7
+VERSION=5.8.7b
 
 #CC=gcc
 #
@@ -29,6 +28,7 @@
 #
 # $ DEBUG=1 make
 #
+
 ifdef DEBUG
 	CFLAGS += -O0 -g
 else
@@ -40,14 +40,35 @@
 
   ARCHITECTURE = $(shell arch)
 
+  IS_GCC = $(shell $(CC) -v 2>&1 | sed -nE 's/^(.+) version.+$$/\1/p')
+  CC_VERSION = $(shell $(CC) -v 2>&1 | sed -nE 's/^.+version (.).+$$/\1/p')
+
   # Options for x86-64
   ifeq ($(ARCHITECTURE),x86_64)
-    CFLAGS += -march=native -ftree-vectorize -flto -fno-stack-protector
+    CFLAGS += -march=native -mtune=native -ftree-vectorize -flto -fno-stack-protector -mstringop-strategy=rep_byte
+
+		# Avoid CTE on Intel Platforms.
+		# Currently works on GCC 9+ (don't know if works on clang).
+    ifeq ($(IS_GCC),gcc)
+      ifeq ($(shell expr $(CC_VERSION) \>= 9),1)
+        CFLAGS += -fcf-protection=none
+      endif
+    endif
+
     LDFLAGS += -flto
   endif
   # Options for i386
   ifeq ($(ARCHITECTURE),i686)
-    CFLAGS += -march=native -flto -fno-stack-protector
+    CFLAGS += -march=native -mtune=native -flto -fno-stack-protector -mstringop-strategy=rep_byte
+
+		# Avoid CTE on Intel Platforms.
+		# Currently works on GCC 9+ (don't know if works on clang).
+    ifeq ($(IS_GCC),gcc)
+      ifeq ($(shell expr $(CC_VERSION) \>= 9),1)
+        CFLAGS += -fcf-protection=none
+      endif
+    endif
+
     LDFLAGS += -flto
   endif

=== debian/changelog ===
t50 (5.8.7b-1) unstable; urgency=medium

  * New upstream version 5.8.7b
  * Refresh 01_Fix-Makefile.patch.
  * Bump to Standards-Version 4.6.0 (no changes required).
  * Remove non-existent upstream metadata field as per DEP-12.

 -- Marcos Fouces <marcos@debian.org>  Wed, 25 Aug 2021 00:32:32 +0200

t50 (5.8.7-2) unstable; urgency=medium

  [ Marcos Fouces ]
  * Update uploader email to @debian.org.

  [ Samuel Henrique ]
  * Configure git-buildpackage for Debian
  * Bump DH to 13
  * Bump Standards-Version to 4.5.1

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository.
  * Remove obsolete field Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * Update standards version to 4.5.0, no changes needed.

 -- Marcos Fouces <marcos@debian.org>  Thu, 18 Feb 2021 18:08:57 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: utils
 Priority: optional
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
-Uploaders: Marcos Fouces <marcos.fouces@gmail.com>,
+Uploaders: Marcos Fouces <marcos@debian.org>,
            Samuel Henrique <samueloph@debian.org>
-Build-Depends: debhelper-compat (= 12)
-Standards-Version: 4.4.1
+Build-Depends: debhelper-compat (= 13)
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/fredericopissarra/t50
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/t50

## t50 5.8.7c

=== Makefile ===
--- 
+++ 
@@ -8,19 +8,36 @@
 # NOTE: I've got rid of autoconf 'cause there is a dependency there.
 #       This way you don't need anything other than this makefile to
 #       compile the project.
-
-VERSION=5.8.7b
+#
+# T50 - Experimental Mixed Packet Injector
+#
+# Copyright (C) 2010 - 2025 - T50 developers
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+VERSION=5.8.7c
 
 #CC=gcc
 #
 # OBS: T50 will compile only on GCC 5 or above. If you are feeling lucky,
 #      try GCC 4.9 or CLANG... But I don't recomended.
-#
 
 LD=$(CC)
+ECHO=/usr/bin/echo
 
 INCLUDEDIR=src/include
-CFLAGS=-std=gnu11 -I $(INCLUDEDIR)
+CFLAGS=-I $(INCLUDEDIR)
 LDFLAGS=
 LDLIBS=
 
@@ -45,7 +62,7 @@
 
   # Options for x86-64
   ifeq ($(ARCHITECTURE),x86_64)
-    CFLAGS += -march=native -mtune=native -ftree-vectorize -flto -fno-stack-protector -mstringop-strategy=rep_byte
+    CFLAGS += -march=native -ftree-vectorize -flto -fno-stack-protector 
 
 		# Avoid CTE on Intel Platforms.
 		# Currently works on GCC 9+ (don't know if works on clang).
@@ -57,9 +74,10 @@
 
     LDFLAGS += -flto
   endif
+
   # Options for i386
   ifeq ($(ARCHITECTURE),i686)
-    CFLAGS += -march=native -mtune=native -flto -fno-stack-protector -mstringop-strategy=rep_byte
+    CFLAGS += -march=native -flto -fno-stack-protector
 
 		# Avoid CTE on Intel Platforms.
 		# Currently works on GCC 9+ (don't know if works on clang).
@@ -85,6 +103,8 @@
     CFLAGS += -march=armv8-a -fno-stack-protector -flto
     LDFLAGS += -flto
   endif
+
+  # TODO: Options for other architectures will go here.
 endif
 
 # Added to use ANSI CSI codes (beautifier).
@@ -143,15 +163,13 @@
 $(EXECUTABLE): $(OBJECTS)
 	$(LD) $(LDFLAGS) -o $@ $^ $(LDLIBS)
 
-# Implicit rules (all .c files will be compiled!)
-src/%.o: src/%.c
-src/help/%.o: src/help/%.c
-src/modules/%.o: src/modules/%.c
+# Rules
+include dependencies.d
 
 # 'clean' only deletes the object files.
 clean:
-	@echo 'Deleting .o files...'
-	-find src/ -type f -name '*.o' -delete
+	@$(ECHO) -e "\e[1;33mDeleting .o files (if any)...\e[m"
+	@-find src/ -type f -name '*.o' -delete
 
 # distclean delete the object files AND the executable.
 distclean: clean
@@ -169,7 +187,7 @@
 install:
 	@$(call checkifroot)
 	@if [ ! -e "$(EXECUTABLE)" ]; then \
-		echo "Try 'make' first."; \
+		$(ECHO) -e "\e[1;31mERROR\e[m: Try 'make' first."; \
 		exit 1; \
 	fi;
 	cp bin/t50 /sbin/; cp doc/t50.8 /usr/share/man/man8/; \
@@ -184,4 +202,4 @@
 
 # Needed to build the project source tarball (no signature generation here).
 dist: distclean
-	tar -czvf dist/t50-$(VERSION).tar.gz --exclude=*.tar.gz --exclude=*.asc *
+	tar -czvf dist/t50-$(VERSION).tar.gz --exclude=*.tar.gz *

=== debian/changelog ===
t50 (5.8.7c-2) unstable; urgency=medium

  * Fix FTBS in armhf architecture (Closes: #1115494).

 -- Marcos Fouces <marcos@debian.org>  Thu, 18 Sep 2025 18:33:27 +0200

t50 (5.8.7c-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

  [ Peter Wienemann ]
  * Fix build failure after successful build (Closes: #1047444, #1049683)

  [ Marcos Fouces ]
  * New upstream version 5.8.7c
  * Refresh/rework patches.
  * Bump to Standards-Version 4.7.2 (no changes required).
  * Update copyright dates.

 -- Marcos Fouces <marcos@debian.org>  Tue, 16 Sep 2025 23:35:34 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Marcos Fouces <marcos@debian.org>,
            Samuel Henrique <samueloph@debian.org>
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/fredericopissarra/t50
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/t50

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build --buildsystem=makefile
